Index: include/asterisk/monitor.h
===================================================================
--- include/asterisk/monitor.h	(revision 38520)
+++ include/asterisk/monitor.h	(working copy)
@@ -69,4 +69,8 @@
 
 int unpause_monitor_exec(struct ast_channel *chan, void *data);
 
+/*! Since some ast format are exception to soxmix 
+ * Returns the known soxmix format, for these few exception, or their own name othewise */
+char *ast_get_soxmix_format(char *format);
+
 #endif /* _ASTERISK_MONITOR_H */
Index: res/res_monitor.c
===================================================================
--- res/res_monitor.c	(revision 38520)
+++ res/res_monitor.c	(working copy)
@@ -189,8 +189,12 @@
 		} else {
 			monitor->format = strdup("wav");
 		}
+	
+		/* Since some format could be tricky for soxmix */
+		monitor->format = ast_get_soxmix_format(monitor->format);
 		
 		/* open files */
+		ast_log(LOG_DEBUG, "monitor->format=%s\n",monitor->format);
 		if (ast_fileexists(monitor->read_filename, NULL, NULL) > 0) {
 			ast_filedelete(monitor->read_filename, NULL);
 		}
@@ -289,7 +293,7 @@
 			if (ast_strlen_zero(execute_args)) {
 				execute_args = "";
 			}
-			
+
 			snprintf(tmp, sizeof(tmp), "%s \"%s/%s-in.%s\" \"%s/%s-out.%s\" \"%s/%s.%s\" %s &", execute, dir, name, format, dir, name, format, dir, name, format,execute_args);
 			if (delfiles) {
 				snprintf(tmp2,sizeof(tmp2), "( %s& rm -f \"%s/%s-\"* ) &",tmp, dir ,name); /* remove legs when done mixing */
@@ -310,7 +314,17 @@
 	return 0;
 }
 
+char *ast_get_soxmix_format(char *format) {
+	if ( !strcasecmp(format,"ulaw") )
+		return strdup("ul");
+	if ( !strcasecmp(format,"alaw") )
+		return strdup("al");
+	if ( !strcasecmp(format,"wav49") )
+		return strdup("WAV");
+	return format;
+}
 
+
 /* Pause monitoring of a channel */
 int ast_monitor_pause(struct ast_channel *chan)
 {
@@ -321,6 +335,7 @@
 int ast_monitor_unpause(struct ast_channel *chan)
 {
 	return ast_monitor_set_state(chan, AST_MONITOR_RUNNING);
+	return ast_monitor_set_state(chan, AST_MONITOR_RUNNING);
 }
 
 int pause_monitor_exec(struct ast_channel *chan, void *data)
@@ -673,5 +688,4 @@
 {
 	return ASTERISK_GPL_KEY;
 }
-
 STD_MOD(MOD_0 | NO_USECOUNT | NO_UNLOAD, NULL, NULL, NULL);	/* MOD_0 because it exports some symbols */
